Package net.sf.saxon.tree.linked

## Class LinkedTreeBuilder

- java.lang.Object
- - net.sf.saxon.event.Builder
  - - net.sf.saxon.tree.linked.LinkedTreeBuilder

- All Implemented Interfaces:
    `javax.xml.transform.Result`, `Receiver`

      public class LinkedTreeBuilder
      extends Builder

  The LinkedTreeBuilder class is responsible for taking a stream of Receiver events and constructing a Document tree using the linked tree implementation.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.event.Builder

      `AXIOM_TREE, baseURI, config, currentRoot, DOMINO_TREE, JDOM_TREE, JDOM2_TREE, lineNumbering, LINKED_TREE, MUTABLE_LINKED_TREE, namePool, open, pipe, started, systemId, timing, TINY_TREE, TINY_TREE_CONDENSED, uniformBaseURI, UNSPECIFIED_TREE_MODEL, useEventLocation`

    - ### Fields inherited from interface javax.xml.transform.Result

      `PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `LinkedTreeBuilder​(PipelineConfiguration pipe)` | Create a Builder and initialise variables
    `LinkedTreeBuilder​(PipelineConfiguration pipe, boolean mutable)` | Create a Builder and initialise variables

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `characters​(java.lang.CharSequence chars, Location locationId, int properties)` | Notify a text node.
    `void` | `close()` | Close the stream of Receiver events
    `void` | `comment​(java.lang.CharSequence chars, Location locationId, int properties)` | Notify a comment
    `void` | `endDocument()` | Notify the end of the document
    `void` | `endElement()` | Notify the end of an element
    `BuilderMonitor` | `getBuilderMonitor()` | Get a builder monitor for this builder.
    `NodeImpl` | `getCurrentLeafNode()` | Get the current text, comment, or processing instruction node
    `ParentNodeImpl` | `getCurrentParentNode()` | Get the current document or element node
    `NodeInfo` | `getCurrentRoot()` | Get the current root node.
    `void` | `graftElement​(ElementImpl element)` | graftElement() allows an element node to be transferred from one tree to another.
    `void` | `open()` | Open the stream of Receiver events
    `void` | `processingInstruction​(java.lang.String name, java.lang.CharSequence remainder, Location locationId, int properties)` | Notify a processing instruction
    `void` | `reset()` | Reset the builder to its initial state.
    `void` | `setAllocateSequenceNumbers​(boolean allocate)` | Set whether the builder should allocate sequence numbers to elements as they are added to the tree.
    `void` | `setNodeFactory​(NodeFactory factory)` | Set the Node Factory to use.
    `void` | `setUnparsedEntity​(java.lang.String name, java.lang.String uri, java.lang.String publicId)` | Set an unparsed entity URI for the document
    `void` | `startDocument​(int properties)` | Start of a document node.
    `void` | `startElement​(NodeName elemName, SchemaType type, AttributeMap suppliedAttributes, NamespaceMap namespaces, Location location, int properties)` | Notify the start of an element

    - ### Methods inherited from class net.sf.saxon.event.Builder

      `getBaseURI, getConfiguration, getPipelineConfiguration, getSystemId, isTiming, isUseEventLocation, setBaseURI, setLineNumbering, setPipelineConfiguration, setSystemId, setTiming, setUseEventLocation, usesTypeAnnotations`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.event.Receiver

      `append, append, handlesAppend`

- - ### Constructor Detail

    - #### LinkedTreeBuilder

          public LinkedTreeBuilder​(PipelineConfiguration pipe)

      Create a Builder and initialise variables
      Parameters:
        `pipe` - the pipeline configuration

    - #### LinkedTreeBuilder

          public LinkedTreeBuilder​(PipelineConfiguration pipe,
                                   boolean mutable)

      Create a Builder and initialise variables
      Parameters:
        `pipe` - the pipeline configuration
        `mutable` - set to true if the tree is to be mutable

  - ### Method Detail

    - #### getCurrentRoot

          public NodeInfo getCurrentRoot()

      Get the current root node. This will normally be a document node, but if the root of the tree is an element node, it can be an element.
      Overrides:
        `getCurrentRoot` in class `Builder`
      Returns:
        the root of the tree that is currently being built, or that has been most recently built using this builder

    - #### reset

          public void reset()

      Description copied from class: `Builder`
      Reset the builder to its initial state. The most important effect of calling this method (implemented in subclasses) is to release any links to the constructed document tree, allowing the memory occupied by the tree to released by the garbage collector even if the Builder is still in memory. This can happen because the Builder is referenced from a parser in the Configuration's parser pool.
      Overrides:
        `reset` in class `Builder`

    - #### setAllocateSequenceNumbers

          public void setAllocateSequenceNumbers​(boolean allocate)

      Set whether the builder should allocate sequence numbers to elements as they are added to the tree. This is normally done, because it provides a quick way of comparing document order. But nodes added using XQuery update are not sequence-numbered.
      Parameters:
        `allocate` - true if sequence numbers are to be allocated

    - #### setNodeFactory

          public void setNodeFactory​(NodeFactory factory)

      Set the Node Factory to use. If none is specified, the Builder uses its own.
      Parameters:
        `factory` - the node factory to be used. This allows custom objects to be used to represent the elements in the tree.

    - #### open

          public void open()

      Open the stream of Receiver events
      Specified by:
        `open` in interface `Receiver`
      Overrides:
        `open` in class `Builder`

    - #### startDocument

          public void startDocument​(int properties)
                             throws XPathException

      Start of a document node. This event is ignored: we simply add the contained elements to the current document
      Parameters:
        `properties` - properties of the document node
      Throws:
        `XPathException` - if an error occurs

    - #### endDocument

          public void endDocument()
                           throws XPathException

      Notify the end of the document
      Throws:
        `XPathException` - if an error occurs

    - #### close

          public void close()
                     throws XPathException

      Close the stream of Receiver events
      Specified by:
        `close` in interface `Receiver`
      Overrides:
        `close` in class `Builder`
      Throws:
        `XPathException` - if an error occurs

    - #### startElement

          public void startElement​(NodeName elemName,
                                   SchemaType type,
                                   AttributeMap suppliedAttributes,
                                   NamespaceMap namespaces,
                                   Location location,
                                   int properties)
                            throws XPathException

      Notify the start of an element
      Parameters:
        `elemName` - the name of the element.
        `type` - the type annotation of the element.
        `suppliedAttributes` - the attributes of this element
        `namespaces` - the in-scope namespaces of this element: generally this is all the in-scope namespaces, without relying on inheriting namespaces from parent elements
        `location` - an object providing information about the module, line, and column where the node originated
        `properties` - bit-significant properties of the element node. If there are no relevant properties, zero is supplied. The definitions of the bits are in class `ReceiverOption`
      Throws:
        `XPathException` - if an error occurs

    - #### endElement

          public void endElement()
                          throws XPathException

      Notify the end of an element
      Throws:
        `XPathException` - if an error occurs

    - #### characters

          public void characters​(java.lang.CharSequence chars,
                                 Location locationId,
                                 int properties)
                          throws XPathException

      Notify a text node. Adjacent text nodes must have already been merged
      Parameters:
        `chars` - The characters
        `locationId` - provides information such as line number and system ID.
        `properties` - Bit significant value. The following bits are defined:
        DISABLE_ESCAPING
          Disable escaping for this text node
        USE_CDATA
          Output as a CDATA section
      Throws:
        `XPathException` - if an error occurs

    - #### processingInstruction

          public void processingInstruction​(java.lang.String name,
                                            java.lang.CharSequence remainder,
                                            Location locationId,
                                            int properties)

      Notify a processing instruction
      Parameters:
        `name` - The PI name. This must be a legal name (it will not be checked).
        `remainder` - The data portion of the processing instruction
        `locationId` - provides information such as line number and system ID.
        `properties` - Additional information about the PI.

    - #### comment

          public void comment​(java.lang.CharSequence chars,
                              Location locationId,
                              int properties)
                       throws XPathException

      Notify a comment
      Parameters:
        `chars` - The content of the comment
        `locationId` - provides information such as line number and system ID.
        `properties` - Additional information about the comment.
      Throws:
        `XPathException` - if an error occurs

    - #### getCurrentParentNode

          public ParentNodeImpl getCurrentParentNode()

      Get the current document or element node
      Returns:
        the most recently started document or element node (to which children are currently being added) In the case of elements, this is only available after startContent() has been called

    - #### getCurrentLeafNode

          public NodeImpl getCurrentLeafNode()

      Get the current text, comment, or processing instruction node
      Returns:
        if any text, comment, or processing instruction nodes have been added to the current parent node, then return that text, comment, or PI; otherwise return null

    - #### graftElement

          public void graftElement​(ElementImpl element)

      graftElement() allows an element node to be transferred from one tree to another. This is a dangerous internal interface which is used only to contruct a stylesheet tree from a stylesheet using the "literal result element as stylesheet" syntax. The supplied element is grafted onto the current element as its only child.
      Parameters:
        `element` - the element to be grafted in as a new child.

    - #### setUnparsedEntity

          public void setUnparsedEntity​(java.lang.String name,
                                        java.lang.String uri,
                                        java.lang.String publicId)

      Set an unparsed entity URI for the document
      Parameters:
        `name` - The name of the unparsed entity
        `uri` - The system identifier of the unparsed entity
        `publicId` - The identifier of the unparsed entity

    - #### getBuilderMonitor

          public BuilderMonitor getBuilderMonitor()

      Get a builder monitor for this builder. This must be called immediately after opening the builder, and all events to the builder must thenceforth be sent via the BuilderMonitor.
      Overrides:
        `getBuilderMonitor` in class `Builder`
      Returns:
        a new BuilderMonitor appropriate to this kind of Builder; or null if the Builder does not provide this service